//
//  MasterViewController.m
//  FriendREST
//
//  Created by Kanybek Momukeyev on 3/7/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MasterViewController.h"
#import "DetailViewController.h"

#import "SBJSON.h"
#import <RestKit/RKRequestSerialization.h>
#import <RestKit/RKRouter.h>


#import "Friend.h"
#import "User.h"

@implementation MasterViewController

@synthesize detailViewController = _detailViewController;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = NSLocalizedString(@"Master", @"Master");
    }
    return self;
}
							
- (void)dealloc
{
    [_detailViewController release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
   
    
    [self performSelector:@selector(getAllFriends)];
}



- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation  = UIInterfaceOrientationPortraitUpsideDown);
}



#pragma mark - 
#pragma mark Reachibility methods

- (void)demoReachability {
      // Check if the network is available
      [[RKClient sharedClient] isNetworkReachable];  
      // Register for changes in network availability
      NSNotificationCenter* center = [NSNotificationCenter defaultCenter];
      [center addObserver:self selector:@selector(reachabilityDidChange:) name:RKReachabilityDidChangeNotification object:nil];
}


- (void)reachabilityDidChange:(NSNotification *)notification {
    
    RKReachabilityObserver* observer = (RKReachabilityObserver *) [notification object];
    RKReachabilityNetworkStatus status = [observer networkStatus];
    
    if(status == RKReachabilityNotReachable){
        NSLog(@"NOT REA");
    }
    else if(status == RKReachabilityReachableViaWiFi) {
        NSLog(@"REACH WIFI");
    }
    else if(status == RKReachabilityReachableViaWWAN) {
        NSLog(@"REACH 3G");
    }
    else if(status == RKReachabilityNotReachable) {
        NSLog(@"NOT REA");
    }
}



#pragma mark - 
#pragma mark ONE BIG EXAMLE methods

-(void)postUser{
    
    RKLogConfigureByName("RestKit/Network", RKLogLevelTrace);
    
    
    RKObjectManager* objectManager = [RKObjectManager objectManagerWithBaseURL:@"http://gifthelp.ru/api"];
    objectManager.objectStore = [RKManagedObjectStore objectStoreWithStoreFilename:@"RKRelationshipMappingExample.sqlite"];
    

    
    RKManagedObjectMapping* articleMapping = [RKManagedObjectMapping mappingForEntityWithName:@"User"];
    [articleMapping mapKeyPath:@"id" toAttribute:@"userID"];
    [articleMapping mapKeyPath:@"name" toAttribute:@"name"];
    [articleMapping mapKeyPath:@"phone" toAttribute:@"phone"];
    [articleMapping mapKeyPath:@"udid" toAttribute:@"udid"];
    articleMapping.primaryKeyAttribute = @"userID";
    
    
    
    
    
    RKObjectRouter* router = [[RKObjectRouter new] autorelease];
    [router routeClass:[User class] toResourcePath:@"/users/create" forMethod:RKRequestMethodPOST];
    
    [RKObjectManager sharedManager].router = router;
    
    
    
    
    [[RKObjectManager sharedManager].mappingProvider addObjectMapping:articleMapping];
    [[RKObjectManager sharedManager].mappingProvider setSerializationMapping:[articleMapping inverseMapping] forClass:[User class]];
    
    [[RKObjectManager sharedManager] setSerializationMIMEType:RKMIMETypeJSON];
    [[RKObjectManager sharedManager] setAcceptMIMEType:RKMIMETypeJSON];
    
    
    User* blake = [User object];
    blake.udid = [NSString stringWithFormat:@"%@123",[UIDevice currentDevice].uniqueIdentifier];
    blake.name = @"Blake Watters";
    blake.phone = @"987654321";
    

    [[RKObjectManager sharedManager] postObject:blake mapResponseWith:articleMapping delegate:self]; 
}

- (void)getUser {
    
    RKObjectManager* objectManager = [RKObjectManager objectManagerWithBaseURL:@"http://gifthelp.ru/api"];
    objectManager.objectStore = [RKManagedObjectStore objectStoreWithStoreFilename:@"RKRelationshipMappingExample.sqlite"];
    
    RKManagedObjectMapping* articleMapping = [RKManagedObjectMapping mappingForEntityWithName:@"User"];
    [articleMapping mapKeyPath:@"id" toAttribute:@"userID"];
    [articleMapping mapKeyPath:@"name" toAttribute:@"name"];
    [articleMapping mapKeyPath:@"phone" toAttribute:@"phone"];
    [articleMapping mapKeyPath:@"udid" toAttribute:@"udid"];
    articleMapping.primaryKeyAttribute = @"userID";
    
    
    
    
    
    RKObjectRouter* router = [[RKObjectRouter new] autorelease];
    [router routeClass:[User class] toResourcePath:@"/users/show" forMethod:RKRequestMethodGET];
    
    [RKObjectManager sharedManager].router = router;
    
    
    
    
    [[RKObjectManager sharedManager].mappingProvider addObjectMapping:articleMapping];
    [[RKObjectManager sharedManager].mappingProvider setSerializationMapping:[articleMapping inverseMapping] forClass:[User class]];
    
    [[RKObjectManager sharedManager] setSerializationMIMEType:RKMIMETypeJSON];
    [[RKObjectManager sharedManager] setAcceptMIMEType:RKMIMETypeJSON];
    
    
    User* blake = [User object];
    blake.udid = [NSString stringWithFormat:@"%@123",[UIDevice currentDevice].uniqueIdentifier];
    
    [[RKObjectManager sharedManager] getObject:blake mapResponseWith:articleMapping delegate:self]; 
}


- (void)postFriend {
    
}

- (void)putFriend {
    
}

- (void)deleteFriend {
    
}


- (void)getAllFriendsWithRKClient {
    
    RKClient  *client = [[RKClient alloc] initWithBaseURL:@"http://gifthelp.ru/api"];
    [client get:[NSString stringWithFormat:@"/persons/list?udid=%@",[UIDevice currentDevice].uniqueIdentifier] delegate:self];  
}

- (void)getAllFriends {
    
    RKObjectManager* objectManager = [RKObjectManager objectManagerWithBaseURL:@"http://gifthelp.ru/api"];
    objectManager.objectStore = [RKManagedObjectStore objectStoreWithStoreFilename:@"RKRelationshipMappingExample.sqlite"];
    
    RKManagedObjectMapping* articleMapping = [RKManagedObjectMapping mappingForEntityWithName:@"Friend"];
    [articleMapping mapKeyPath:@"id" toAttribute:@"friendID"];
    [articleMapping mapKeyPath:@"birthday" toAttribute:@"birthDate"];
    [articleMapping mapKeyPath:@"first_name" toAttribute:@"firstName"];
    [articleMapping mapKeyPath:@"second_name" toAttribute:@"secondName"];
    articleMapping.primaryKeyAttribute = @"friendID";

    [RKObjectMapping addDefaultDateFormatterForString:@"E MMM d HH:mm:ss Z y" inTimeZone:nil];

    
    
    
    RKObjectRouter* router = [[RKObjectRouter new] autorelease];
    
    // [User class] OR [Friend class] ???
    [router routeClass:[Friend class] toResourcePath:@"/persons/list" forMethod:RKRequestMethodGET];
    
    [RKObjectManager sharedManager].router = router;
    
    
    
    
    [[RKObjectManager sharedManager].mappingProvider addObjectMapping:articleMapping];
    [[RKObjectManager sharedManager].mappingProvider setSerializationMapping:[articleMapping inverseMapping] forClass:[Friend class]];
    
    [[RKObjectManager sharedManager] setSerializationMIMEType:RKMIMETypeJSON];
    [[RKObjectManager sharedManager] setAcceptMIMEType:RKMIMETypeJSON];
    
    
    Friend* blake = [Friend object];
    //blake.udid = [NSString stringWithFormat:@"%@",[UIDevice currentDevice].uniqueIdentifier];
    
    [[RKObjectManager sharedManager] getObject:blake mapResponseWith:articleMapping delegate:self];  
}

#pragma mark - 
#pragma mark RKObjectLoaderDelegate methods


- (void)objectLoader:(RKObjectLoader *)objectLoader didLoadObjects:(NSArray *)objects {
   
    /*
    RKRequestMethodGET = 0,
    RKRequestMethodPOST,
    RKRequestMethodPUT,
    RKRequestMethodDELETE,
    RKRequestMethodHEAD
    */
    
    /*
    if([objectLoader method] != RKRequestMethodPUT) {
        NSLog(@"%@",objects);
        User *user = [objects objectAtIndex:0];
        NSLog(@"Loaded Contact ID #%@ -> Name: %@, Company: %@", user.userID, user.phone, user.udid);
    }
    */
    
    if([objectLoader method] != RKRequestMethodPUT) {
        NSLog(@"%@",objects);
        Friend *friend = [objects objectAtIndex:0];
        NSLog(@"Loaded Contact ID #%@ -> Name: %@, Company: %@", friend.friendID, friend.firstName, friend.secondName);
    }
}

- (void)objectLoader:(RKObjectLoader *)objectLoader didFailWithError:(NSError *)error {
    NSLog(@"Encountered an error: %@", error);
}




#pragma mark - 
#pragma mark RKRequestDelegate methods


- (void)request:(RKRequest *)request didLoadResponse:(RKResponse *)response {
    if([request isGET]) {
        NSLog(@"%@",[response bodyAsString]);
    }
}


- (void)request:(RKRequest *)request didFailLoadWithError:(NSError *)error {
    
}






#pragma mark - 
#pragma mark UITableView methods

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 1;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }

    // Configure the cell.
    cell.textLabel.text = NSLocalizedString(@"Detail", @"Detail");
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    } else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if ( self.detailViewController) {
        self.detailViewController = [[[DetailViewController alloc] initWithNibName:@"DetailViewController" bundle:nil] autorelease];
    }
    [self.navigationController pushViewController:self.detailViewController animated:YES];
}

@end
